//  iyv12prop.cpp
//
//	YV12 to YUY2 converter PropertyPages
//
//	Copyright (c)
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>
#include <streams.h>
#include <initguid.h>

#include "iyv12guids.h"
#include "iyv12prop.h"
#include "resource.h"

// -----------------------------------------

CUnknown * WINAPI Ciyv12Prop::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    Ciyv12Prop * pNewObject = new Ciyv12Prop(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


Ciyv12Prop::Ciyv12Prop(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("IYV12Prop"), pUnk, IDD_IYV12Prop, IDS_IYV12Prop)
	,m_pIYV12(0)
{

}
void Ciyv12Prop::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT Ciyv12Prop::OnConnect(IUnknown *pUnk)
{
	if (pUnk == NULL)
    {
        return E_POINTER;
    }
    ASSERT(m_pIYV12 == NULL);

	HRESULT hr;
        // pUnk ŃtB^̃JX^ C^[tFCX₢킹B
    hr = pUnk->QueryInterface(IID_IIYV12,
             reinterpret_cast<void**>(&m_pIYV12));
    return hr;
}

HRESULT Ciyv12Prop::OnActivate(void)
{
    ASSERT(m_pIYV12 != NULL);
    HRESULT hr = m_pIYV12->GetN(&m_dwVal);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_P1+m_dwVal, BM_SETCHECK, BST_CHECKED, 0);
	}

	return S_OK;
}

BOOL Ciyv12Prop::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		switch ( wParam )
		{
		case IDC_P1:
			m_dwNewVal = 0;
			SetDirty();
			break;
		case IDC_P2:
			m_dwNewVal = 1;
			SetDirty();
			break;
		case IDC_P4:
			m_dwNewVal = 2;
			SetDirty();
			break;
		case IDC_P6:
			m_dwNewVal = 3;
			SetDirty();
			break;
		case IDC_I1:
			m_dwNewVal = 4;
			SetDirty();
			break;
		case IDC_I2:
			m_dwNewVal = 5;
			SetDirty();
			break;
		case IDC_I2X:
			m_dwNewVal = 6;
			SetDirty();
			break;
		case IDC_I4:
			m_dwNewVal = 7;
			SetDirty();
			break;
		case IDC_I4X:
			m_dwNewVal = 8;
			SetDirty();
			break;
		case IDC_I6:
			m_dwNewVal = 9;
			SetDirty();
			break;
		case IDC_I6X:
			m_dwNewVal = 10;
			SetDirty();
			break;
		default :
			return FALSE;
		}
		break;

	default :
		return FALSE;
	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT Ciyv12Prop::OnApplyChanges(void)
{
	m_dwVal = m_dwNewVal;
	m_pIYV12->SetN(m_dwVal);
	return S_OK;
}

HRESULT Ciyv12Prop::OnDisconnect(void)
{
    if (m_pIYV12)
    {
		m_pIYV12->SetN(m_dwVal);
        m_pIYV12->Release();
        m_pIYV12 = NULL;
    }
    return S_OK;
}




DWORD LoadRegistryInfo()
{
	HKEY hKey;
	DWORD size,ret;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);

	size=sizeof(ret); 
	if(RegQueryValueEx(hKey, "iyv12_mode", NULL, NULL, (LPBYTE)&ret, &size) != ERROR_SUCCESS)
	{ 
		ret = 0;
	}

	RegCloseKey(hKey);

	return ret;
}

void SaveRegistryInfo(DWORD i)
{
	HKEY hKey;
	DWORD dispo;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString("Couldn't create HWDI_REG_SUBKEY");
		return;
	}

	RegSetValueEx(hKey, "iyv12_mode", 0, REG_DWORD, (LPBYTE)&i, sizeof(DWORD));

	RegCloseKey(hKey);
}

